%Returnerer gradienten til den negative partielle log-likelihooden med evt straff
%It is essential that the observations are ordrered descending according to time of event

function[gradient] = gradPartLik(beta,betaIndex,data,penalty)
%Dette er HegeBs for  plukke ut et subsett av kovariater.
data=[data(:,1:2) data(:,betaIndex+2)];

deathIndex=data(:,2);
X=data(:,3:end); %extract the covariates
eXp = exp(X*beta); % exponent
matrixExp = repmat(eXp,1,size(X,2)); %nxp matrix concisting of p eXp columns.
uu = X .* matrixExp; % nxp matrix 
cumUU = cumsum(uu,1); %cumsum on the columns of uu

cumEXP = cumsum(eXp,1); %cumsum on eXp
matrixcumExp = repmat(cumEXP,1,size(X,2));
frac = cumUU ./ matrixcumExp;
deathIndex2 = repmat(deathIndex,1,size(X,2));
product = deathIndex2.*X;
test1 = sum(product,1);
fracReal = deathIndex2.*frac;
test= sum(fracReal,1);

gradient = test'-test1' + (2*penalty*beta);


