function pvalue = empiricalTest(stat, distr, direction)
    
    %how many permutations?
    num_perms = length(distr);
    
    %let's calculate the p value
    if strcmp(direction, 'G')
        numerator = sum(distr >= stat);
        pvalue = numerator/num_perms;
    end

    if strcmp(direction, 'L')
        numerator = sum(distr <= stat);
        pvalue = numerator/num_perms;
    end

    if strcmp(direction, 'D')
        numerator = min(sum(distr <= stat),sum(distr >= stat));
        pvalue = 2*numerator/num_perms;
    end
