
%This script provide an example of SMMPC operation

%loading the data
load 1_vanVijver

%set the parameter
option.threshold = 0.05;
option.max_k = 2;

%running the algorithm
[pc statistics] = SMMPC(data, time, censored, option);

%Display the selected variables:
disp(['Selected variables: ' num2str(pc)]);

%Display the association among variables and:
disp(sprintf('%s\n', 'Association with T (lower value bigger association):'));
disp(num2str([1:size(data,2);statistics(1,:)]'));