function[betaHat]=QRsolver(data,n,p,penalty)

%antar at data er skalert og sentrert fr de sendes hit.

X=data(:,3:(p+2));

[Q R] = qr(X',0);

Rmatrix = [data(:,1:2) R'];

betaInit=zeros(n,1);

%fprintf('Her p deg\n');

%size(betaInit)

%size(Rmatrix)

%betaTilde=newtonBFGS(@penPartLik, @gradPenPartLik, betaInit, Rmatrix, penalty,1e-3,500,100);

%fprintf('Her p degettet\n');

%betaTilde

%if(betaTilde==0)

%   fprintf('Min teite optimeringsalgoritme funker ikke!!!\n')

   options = optimset('GradObj','on','MaxFunEvals',1000000, 'TolX',1e-15,'TolFun',1e-15, 'MaxIter', 1000,'Display','on');   

   [betaTilde,FVAL,EXITFLAG,OUTPUT,GRAD,HESSIAN]=fminunc('retFunAndGrad', betaInit, options, 1:n,Rmatrix, penalty);   

   try

    chol(HESSIAN);

    betaHat = Q*betaTilde; 

   catch

       fprintf('Hessematrisen er ikke positiv definitt\n')

       betaHat=0;

   end

   %clear HESSIAN FVAL EXITFLAG OUTPUT GRAD

   %end   

%fprintf('rett fr retur\n');

%betaHat   

  

